package org.semanticweb.triple.inference;

/*
 *  Name: TermSet.java
 *  Version: 1.0
 *  Purpose:
 *  History:
 */
import java.util.Hashtable;
import java.io.*;
import java.net.*;
import java.util.*;

/**
 *  Description of the Class
 *
 *@author     Administrator
 *@created    January 17, 2002
 */
class Liste extends Object {
    ListElement first;
    ListElement last;
    ListElement act;
    Hashtable hash;
    int anz;


    /**
     *  Constructor for the Liste object
     */
    public Liste() {
        first = new ListElement(null);
        last = new ListElement(null);
        first.next = last;
        act = null;
        anz = 0;
        hash = new Hashtable();
    }


    /**
     *  Description of the Method
     *
     *@param  key      Description of the Parameter
     *@param  element  Description of the Parameter
     *@return          Description of the Return Value
     */
    public boolean Append(Object key, Object element) {
        if (!hash.containsKey(key)) {
            try {
                last.element = element;
                last.key = key;
                hash.put(key, last);
                last.next = new ListElement(null);
                last = last.next;
                anz++;
            } catch (NullPointerException np) {
                System.out.println("Hashtable overflow");
            }
            return true;
        }
        else {
            return false;
        }
    }


    /**
     *  Description of the Method
     */
    public void ClearList() {
        ListElement l;
        hash = new Hashtable();

        //for(l = first.next; l != last; l = l.next)
        //	hash.remove(l.key);
        first = last = act = null;
        anz = 0;

    }


    /**
     *  Description of the Method
     *
     *@param  list  Description of the Parameter
     */
    public void Concat(Liste list) {
        ListElement l;
        boolean b;
        for (l = list.first.next; l != list.last; l = l.next) {
            b = Append(l.key, l.element);
        }
    }


    /**
     *  Description of the Method
     *
     *@return    Description of the Return Value
     */
    public Object First() {
        act = first.next;
        if (act != null) {
            return act.element;
        }
        else {
            return null;
        }
    }


    /**
     *  Description of the Method
     *
     *@param  key  Description of the Parameter
     *@return      Description of the Return Value
     */
    private ListElement get(Object key) {
        ListElement l;
        if (hash.containsKey(key)) {
            l = (ListElement) hash.get(key);
            return l;
        }
        else {
            return null;
        }
    }


    /**
     *  Description of the Method
     *
     *@param  key  Description of the Parameter
     *@return      Description of the Return Value
     */
    public Object Get(Object key) {
        ListElement l;
        l = get(key);
        if (l != null) {
            return l.element;
        }
        else {
            return null;
        }
    }


    /**
     *  Description of the Method
     *
     *@param  key  Description of the Parameter
     *@return      Description of the Return Value
     */
    public boolean In(Object key) {
        return hash.containsKey(key);
    }


    /**
     *  Description of the Method
     *
     *@param  list1  Description of the Parameter
     *@param  list2  Description of the Parameter
     */
    public void Intersect(Liste list1, Liste list2) {
        ListElement l;
        //l1;
        boolean b;
        if (list1.anz < list2.anz) {
            for (l = list1.first.next; l != list1.last; l = l.next) {
                if (list2.In(l.key)) {
                    b = Append(l.key, l.element);
                }
            }
        }
        else {
            for (l = list2.first.next; l != list2.last; l = l.next) {
                if (list1.In(l.key)) {
                    b = Append(l.key, l.element);
                }
            }
        }
    }


    /**
     *  Description of the Method
     *
     *@return    Description of the Return Value
     */
    public Object Next() {
        if (act != null) {
            act = act.next;
        }
        if (act != last) {
            return act.element;
        }
        else {
            return null;
        }
    }
}
