package org.semanticweb.triple.parser;

import java.util.*;


public class LDouble extends LTerm {

  double doubleNum;

  public LDouble() { }

  public LDouble(String doubleString) {
    this.doubleNum = parseDouble(doubleString);
  }

  public void putDouble(String doubleString) {
    this.doubleNum = parseDouble(doubleString);
  }

  public double getDouble() {
    return doubleNum;
  }

  public String toString() {
    return ""+doubleNum;
  }

  double parseDouble(String doubleString) {
    try {
      return Double.parseDouble(doubleString);
    } catch (Exception e) {
      System.err.println("Double expected: " + doubleString);
      return -1;
    }
  }

}
