package org.semanticweb.triple.parser;

import java.util.*;


public class LInteger extends LTerm {

  int integer;

  public LInteger() { }

  public LInteger(String integerString) {
    this.integer = parseInteger(integerString);
  }

  public void putInteger(String integerString) { // int or Integer ??
    this.integer = parseInteger(integerString);
  }

  public int getInteger() {
    return integer;
  }

  public String toString() {
    return ""+integer;
  }

  int parseInteger(String integerString) {
    try {
      return Integer.parseInt(integerString);
    } catch (Exception e) {
      System.err.println("integer expected: " + integerString);
      return -1;
    }
  }

}
